-#!/bin/sh
+#!/bin/bash
#
# This script is run after receive-pack has accepted a pack and the
# repository has been updated. It is passed arguments in through stdin
instance=$(invirt-getconf "$base.instance" 2>/dev/null)
zsig=$(invirt-getconf "$base.zsig" 2>/dev/null)
color=$(invirt-getconf "$base.color" 2>/dev/null)
+maxlines=`git config --int zephyr.maxlines 2>/dev/null || echo 50`
# Git hooks are always called with PWD == GIT_DIR.
repo=${PWD#/srv/git/}
usecolor=""
fi
+if [ -z "$zsig" ]; then
+ if [ -e "$GIT_DIR/description" ]; then
+ zsig=`cat "$GIT_DIR/description"`
+ fi
+ if [ -z "$zsig" ] || \
+ [ "$zsig" = "Unnamed repository; edit this file to name it for gitweb." ] || \
+ [ "$zsig" = "Unnamed repository; edit this file 'description' to name the repository." ]; then
+ zsig=$(basename "$(cd "$GIT_DIR" && pwd)")
+ if [ "$zsig" = ".git" ]; then
+ zsig=$(basename "$(cd "$GIT_DIR/.." && pwd)")
+ fi
+ fi
+fi
+
if [ -z "$class" ]; then
echo "I don't know where to send a commit zephyr!" >&2
echo "Please provide a value for $base.class in" >&2
echo "your invirt config file." >&2
exit 1
fi
+
+let max=10
+check_max () {
+ if ! let --max; then
+ zwrite -c "$class" -i "${instance:-git}" -s "Aperture Science Emergency Intelligence Incinerator" -d \
+ -m 'Aborting zephyr hook to prevent zwrite flood.'
+ exit 0
+ fi
+}
+
while read oldrev newrev refname; do
if [ "$oldrev" = "0000000000000000000000000000000000000000" ]; then
+ check_max
# dammit git
zwrite -c "$class" -i "$repo" -s "${zsig:-Git}: $refname" -d \
- -m "New branch ${refname#refs/heads/} created."
+ -m "New branch ${refname#refs/heads/} created, currently at $newrev."
continue
fi
- git rev-list --first-parent --reverse "$oldrev..$newrev" | while read rev; do
+ while read rev; do
+ check_max
shortrev=`git log -1 --pretty=format:%h "$rev"`
- (git show --stat -M $usecolor "$rev" |
+ lines=`git show -M "$rev" | wc -l`
+ if [ $lines -lt $maxlines ]; then
+ stat=""
+ else
+ stat="--stat"
+ fi
+ (git show -M $stat $usecolor "$rev" |
sed -e 's/@/@@/g' \
-e 's/}/@(})/g' \
-e 's/\e\[m/}@{/g' \
+ -e 's/\e\[1m/}@b{/g' \
-e 's/\e\[33m/@color(yellow)/g' \
-e 's/\e\[31m/@color(red)/g' \
-e 's/\e\[32m/@color(green)/g' \
+ -e 's/\e\[36m/@color(cyan)/g' \
-e '1s/^/@{/' \
-e '$s/$/}/') |
zwrite -c "$class" -i "${instance:-$repo/$shortrev}" -s "${zsig:-Git}: $refname" -d
- done
+ done < <(git rev-list --first-parent --reverse "$oldrev..$newrev")
done